#pragma once

#include <SFML/Graphics.hpp>
#include <memory>
#include "ltbl/lighting/LightPointEmission.h"

/**
 * @class Wormhole
 * @author POSITIVE MENTAL ATTITUDE
 * @date 06/13/16
 * @file Wormhole.hpp
 * @brief A pretty independent class managing that wormhole.
 */
class Wormhole: public sf::Drawable
{
	public:
		Wormhole();
		virtual ~Wormhole();
		void load(const sf::Texture& texture1, const sf::Texture& texture2);
		void update(sf::Time delta);
		void setPosition(sf::Vector2f position);
		void setPosition(float x, float y);
		sf::Vector2f getPosition();
		std::shared_ptr<ltbl::LightPointEmission>& light();

	private:
		virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const;
		sf::Sprite _sprite;
		std::shared_ptr<ltbl::LightPointEmission> _light;
};

